#include <string.h>
#include "lpc214x.h"
#include "lcd.h"

unsigned long data;
void Delay (unsigned long a) { while (--a!=0); }

void ioSetP0Bit(unsigned char n) // bit number (0--31)
{
  IO0SET=(1<<n);		// Set bit n
}

void ioClrP0Bit(unsigned char n) // bit number (0--31)
{
  IO0CLR=(1<<n);	// Clear bit n
}

void E_Pulse()
{
  ioSetP0Bit(28);	// IOSET_bit.P0_28 = 1; //set E to high
  //Delay(10);
  Delay(100);
  ioClrP0Bit(28);	// IOCLR_bit.P0_28 = 1; //set E to low
}

void LCDInit()
{
//   first set D4, D5, D6, D7, RS, RW, E to output ports
//   IO0DIR0_bit.P0_10 = 1;   //D4
//   IO0DIR0_bit.P0_11 = 1;   //D5
//   IO0DIR0_bit.P0_12 = 1;   //D6
//   IO0DIR0_bit.P0_13 = 1;   //D7
//   IO0DIR0_bit.P0_22 = 1;   //RS
//   IO0DIR0_bit.P0_29 = 1;   //R/W
//   IO0DIR0_bit.P0_28 = 1;   //E
  IO0DIR |= 0x30403c00;

  //LCD initialization
  //step by step (from Gosho) - from DATASHEET

  ioClrP0Bit(22);	// IO0CLR_bit.P0_22 = 1;  //set RS port to 0
  ioClrP0Bit(29);	// IO0CLR_bit.P0_29 = 1;  //set R/W port to 0
  ioClrP0Bit(28);	// IO0CLR_bit.P0_28 = 1;  //set E port to 0

  //Delay(110000);        //delay ~110ms
  Delay(10000);        //delay ~110ms

  ioSetP0Bit(10);	// IO0SET_bit.P0_10 = 1;   //set D4 port to 1
  ioSetP0Bit(11);	// IO0SET_bit.P0_11 = 1;   //set D5 port to 1
  E_Pulse();            //high->low to E port (pulse)
  //Delay(10000);         //delay ~10ms
  Delay(10000);         //delay ~10ms


  ioSetP0Bit(10);	// IO0SET_bit.P0_10 = 1;   //set D4 port to 1
  ioSetP0Bit(11);	// IO0SET_bit.P0_11 = 1;   //set D5 port to 1
  E_Pulse();            //high->low to E port (pulse)
  //Delay(10000);         //delay ~10ms
  Delay(10000);         //delay ~10ms


  ioSetP0Bit(10);	// IO0SET_bit.P0_10 = 1;   //set D4 port to 1
  ioSetP0Bit(11);	// IO0SET_bit.P0_11 = 1;   //set D5 port to 1
  E_Pulse();            //high->low to E port (pulse)
  //Delay(10000);         //delay ~10ms
  Delay(10000);         //delay ~10ms

  ioSetP0Bit(11);	// IO0SET_bit.P0_11 = 1;   //set D5 port to 1
  ioClrP0Bit(10);	// IO0CLR_bit.P0_10 = 1;   //set D4 port to 0
  E_Pulse();            //high->low to E port (pulse)

}

void LCDSendCommand(unsigned long a)
{
  ioClrP0Bit(29);	// IO0CLR_bit.P0_29 = 1;                     //set RW port to 0

  //Delay(2000);                            //delay for LCD char ~2ms
  Delay(20000);                             //delay for LCD char ~2ms
  data = 0x0;

  data = 0xffffff0f | a;                    //get high 4 bits
  IO0CLR |= 0x00003c00;                     //clear D4-D7
  data = data << 6;

  IO0SET = (IO0SET | 0x00003c00) & data;     //set D4-D7
  ioClrP0Bit(22);	// IO0CLR_bit.P0_22 = 1;                      //set RS port to 0 -> display set to comand mode
  E_Pulse();                                 //pulse to set d4-d7 bits


  //data = (a << 4) & 0x000000f0;   	    //get low 4 bits
  //IO0CLR |= 0x000000f0;                    //clear D4-D7
  //data = data <<4;
  data = 0x0;
  a = a<<4;

  data = 0xffffff0f | a;                     //get high 4 bits
  IO0CLR |= 0x00003c00;                      //clear D4-D7
  data = data << 6;
  IO0SET = (IO0SET | 0x00003c00) & data;      //set D4-D7
  ioClrP0Bit(22);	// IO0CLR_bit.P0_22 = 1;                       //set RS port to 0 -> display set to command mode
  E_Pulse();                                  //pulse to set d4-d7 bits

}

void LCDSendChar(unsigned long a)
{

  ioClrP0Bit(29);	// IO0CLR_bit.P0_29 = 1;                    //set RW port to 0

  //Delay(2000);                           //delay for LCD char ~2ms
  Delay(20000);                            //delay for LCD char ~2ms
  data = 0x0;

  data = 0xffffff0f | a;                    //get high 4 bits
  IO0CLR |= 0x00003c00;                     //clear D4-D7
  data = data << 6;

  IO0SET = (IO0SET | 0x00003c00) & data;    //set D4-D7
  ioSetP0Bit(22);	// IO0SET_bit.P0_22 = 1;                     //set RS port to 0 -> display set to comand mode
  E_Pulse();                                //pulse to set d4-d7 bits


  //data = (a << 4) & 0x000000f0;   	    //get low 4 bits
  //IO0CLR |= 0x000000f0;                    //clear D4-D7
  //data = data <<4;
  data = 0x0;
  a = a<<4;


  data = 0xffffff0f | a;                      //get high 4 bits
  IO0CLR |= 0x00003c00;                       //clear D4-D7
  data = data << 6;
  IO0SET = (IO0SET | 0x00003c00) & data;      //set D4-D7
  ioSetP0Bit(22);	// IO0SET_bit.P0_22 = 1;                       //set RS port to 0 -> display set to command mode
  E_Pulse();                                  //pulse to set d4-d7 bits

}

void LCDSendTxt(char* a)
{
  int i;
  for( i=0; i<strlen(a); i++)
  {
    LCDSendChar(a[i]);
  }
}

void SmartUp(void)
{
  int i;
  for( i=0; i<40; i++) LCDSendCommand(CUR_RIGHT);
}

void SmartDown(void)
{
  int i;
  for( i=0; i<40; i++) LCDSendCommand(CUR_LEFT);
}

/*void Light(short a)
{
  if(a == 1)
  {
    IO0SET_bit.P0_21 = 1;
    IO0DIR0_bit.P0_21 = 1;

    IO0SET_bit.P0_25 = 1;
    IO0DIR0_bit.P0_25 = 1;

  }
  if(a == 0)
  {
    IO0SET_bit.P0_21 = 0;
    IO0DIR0_bit.P0_21 = 0;


    IO0SET_bit.P0_25 = 0;
    IO0DIR0_bit.P0_25 = 0;
  }

}*/
